d11824
#!/usr/bin/env bash
d11824
# Configuration files
d11824
#
d11824
# /etc/default/jetty
d11824
#   If it exists, this is read at the start of script. It may perform any
d11824
#   sequence of shell commands, like setting relevant environment variables.
d11824
#
d11824
# /etc/jetty.conf
d11824
#   If found, and no configurations were given on the command line,
d11824
#   the file will be used as this script's configuration.
d11824
#   Each line in the file may contain:
d11824
#     - A comment denoted by the pound (#) sign as first non-blank character.
d11824
#     - The path to a regular file, which will be passed to jetty as a
d11824
#       config.xml file.
d11824
#     - The path to a directory. Each *.xml file in the directory will be
d11824
#       passed to jetty as a config.xml file.
d11824
#     - All other lines will be passed, as-is to the start.jar
d11824
#
d11824
#   The files will be checked for existence before being passed to jetty.
d11824
#
d11824
# Configuration variables
d11824
#
d11824
# JAVA
d11824
#   Command to invoke Java. If not set, java (from the PATH) will be used.
d11824
#
d11824
# JAVA_OPTIONS
d11824
#   Extra options to pass to the JVM
d11824
#
d11824
# JETTY_HOME
d11824
#   Where Jetty is installed. If not set, the script will try go
d11824
#   guess it by first looking at the invocation path for the script,
d11824
#   and then by looking in standard locations as $HOME/opt/jetty
d11824
#   and /opt/jetty. The java system property "jetty.home" will be
d11824
#   set to this value for use by configure.xml files, f.e.:
d11824
#
d11824
#    <Arg><Property name="jetty.home" default="."/>/webapps/jetty.war</Arg>
d11824
#
d11824
# JETTY_BASE
d11824
#   Where your Jetty base directory is.  If not set, the value from
d11824
#   $JETTY_HOME will be used.
d11824
#
d11824
# JETTY_ARGS
d11824
#   The default arguments to pass to jetty.
d11824
#   For example
d11824
#      JETTY_ARGS=jetty.port=8080 jetty.spdy.port=8443 jetty.secure.port=443
d11824
#
d11824
d11824
set -e -C
d11824
d11824
readConfig()
d11824
{
d11824
  echo "Reading $1.."
d11824
  source "$1"
d11824
}
d11824
d11824
CONFIGS=()
d11824
d11824
if [ -f /etc/default/jetty ]; then
d11824
  readConfig /etc/default/jetty
d11824
fi
d11824
d11824
if [ -z "$JETTY_HOME" ]; then
d11824
    JETTY_HOME=/usr/share/jetty
d11824
fi
d11824
d11824
if [ -z "$JETTY_BASE" ]; then
d11824
  JETTY_BASE="$JETTY_HOME"
d11824
fi
d11824
d11824
cd "$JETTY_BASE"
d11824
JETTY_BASE="$PWD"
d11824
d11824
if [ -z "$JETTY_CONF" ]
d11824
then
d11824
  JETTY_CONF=/etc/jetty.conf
d11824
fi
d11824
d11824
if [ -f "$JETTY_CONF" ] && [ -r "$JETTY_CONF" ]
d11824
then
d11824
  while read -r CONF
d11824
  do
d11824
    if expr "$CONF" : '#' >/dev/null ; then
d11824
      continue
d11824
    fi
d11824
d11824
    if [ -d "$CONF" ]
d11824
    then
d11824
      # assume it's a directory with configure.xml files
d11824
      # for example: /etc/jetty.d/
d11824
      # sort the files before adding them to the list of JETTY_ARGS
d11824
      for XMLFILE in "$CONF/"*.xml
d11824
      do
d11824
        if [ -r "$XMLFILE" ] && [ -f "$XMLFILE" ]
d11824
        then
d11824
          JETTY_ARGS+=("$XMLFILE")
d11824
        else
d11824
          echo "** WARNING: Cannot read '$XMLFILE' specified in '$JETTY_CONF'"
d11824
        fi
d11824
      done
d11824
    else
d11824
      # assume it's a command line parameter (let start.jar deal with its validity)
d11824
      JETTY_ARGS+=("$CONF")
d11824
    fi
d11824
  done < "$JETTY_CONF"
d11824
fi
d11824
d11824
if [ -z "$JAVA" ]
d11824
then
d11824
    . /usr/share/java-utils/java-functions
d11824
    set_jvm
d11824
    set_javacmd
d11824
    JAVA="$JAVACMD"
d11824
fi
d11824
d11824
if [ -z "$JETTY_LOGS" ] && [ -d $JETTY_BASE/logs ]
d11824
then
d11824
  JETTY_LOGS=/var/log/jetty/logs
d11824
fi
d11824
JAVA_OPTIONS+=("-Djetty.logs=$JETTY_LOGS")
d11824
d11824
JAVA_OPTIONS+=("-Djetty.home=$JETTY_HOME" "-Djetty.base=$JETTY_BASE")
d11824
d11824
JETTY_START="$JETTY_HOME/start.jar"
d11824
START_INI="$JETTY_BASE/start.ini"
d11824
if [ ! -f "$START_INI" ]
d11824
then
d11824
  echo "Cannot find a start.ini in your JETTY_BASE directory: $JETTY_BASE" 2>&2
d11824
  exit 1
d11824
fi
d11824
d11824
RUN_ARGS=(${JAVA_OPTIONS[@]} -jar "$JETTY_START" ${JETTY_ARGS[*]})
d11824
RUN_CMD=("$JAVA" ${RUN_ARGS[@]})
d11824
d11824
echo -n "Starting Jetty: "
d11824
${RUN_CMD[*]}